#!/bin/bash
echo "Generation acsmi monitoring client jaxrs script"
#apt-get update
#apt-get install -y wget
URL="http://localhost:8080/monitoringmanager/swagger.json"

BASE_PATH=$(cygpath $CURRENT_DIR)
TMP_RELATIVE_NAME="tmp/eu.decideh2020.acsmi.monitoring.client"
TARGET_RELATIVE_PATH="git/WP5/ACSmI_monitoring/eu.decideh2020.acsmi.monitoring.client"

TARGET_DIR="$BASE_PATH/$TARGET_RELATIVE_PATH"
ORIG_FILE="$BASE_PATH/$TARGET_RELATIVE_PATH/swagger.json"
ORIG_CONFIG_FILE="$BASE_PATH/$TARGET_RELATIVE_PATH/config.json"
TMP_DIR="$BASE_PATH/$TMP_RELATIVE_NAME"
TMP_FILE="$BASE_PATH/$TMP_RELATIVE_NAME/swagger.json"

WIN_TARGET_DIR="$CURRENT_DIR/$TARGET_RELATIVE_PATH"
WIN_ORIG_FILE="$CURRENT_DIR/$TARGET_RELATIVE_PATH/swagger.json"
WIN_ORIG_CONFIG_FILE="$CURRENT_DIR/$TARGET_RELATIVE_PATH/config.json"
WIN_TMP_DIR="$CURRENT_DIR/$TMP_RELATIVE_NAME"
WIN_TMP_FILE="$CURRENT_DIR/$TMP_RELATIVE_NAME/swagger.json"

mkdir -p $TMP_DIR

echo "URL=$URL"
#$(curl --output /dev/null --silent --head --fail $URL) it does not work it returns 500
until [[ $(curl --silent $URL) == *"swagger"* ]]; do
    printf 'waiting for acsmi'
    sleep 5
done
wget -q -O $TMP_FILE $URL

if [[ $(diff $TMP_FILE $ORIG_FILE 2>&1) == "" ]]; then
	printf 'swagger is equal'
	exit 0
fi

# si no es igual tengo que sustituirlo y generar el cliente
mkdir -p $TARGET_DIR

cp $TMP_FILE $ORIG_FILE

if !  $( java -version 2>&1 >/dev/null | grep -q "Runtime Environment" ) ; then
	apt-get update
	apt-get install -y default-jdk
fi

java -jar $CURRENT_DIR/swagger-codegen/modules/swagger-codegen-cli/target/swagger-codegen-cli.jar generate -i $WIN_ORIG_FILE -l jaxrs-cxf-client -o $WIN_TMP_DIR -c $WIN_ORIG_CONFIG_FILE

CHANGED=0

if ! [[ $(diff $TMP_DIR/pom.xml $TARGET_DIR/pom.xml 2>&1) == "" ]]; then
	printf 'pom.xml is different'
	cp $TMP_DIR/pom.xml $TARGET_DIR/pom.xml
	CHANGED=1
fi

if ! [[ $(diff $TMP_DIR/src/gen/java $TARGET_DIR/src/gen/java 2>&1) == "" ]]; then
	printf 'code is different'
	rm -rf $TARGET_DIR/src/gen/java
	mkdir -p $TARGET_DIR/src/gen/java
	cp -rp $TMP_DIR/src/gen/java $TARGET_DIR/src/gen
	CHANGED=1
fi

AUTHOR_GIT_PATH=$(cygpath $CREDENTIALS_HOME)/git/author.git
source $AUTHOR_GIT_PATH

if ((CHANGED)); then
	cd $TARGET_RELATIVE_PATH
	git add .
	git -c user.email="$GIT_USER_EMAIL" -c user.name="$GIT_USER_NAME" commit -m "adds changed version of acsmi monitoring client"
fi

