package eu.decideh2020.acsmi.monitoring.server.api;

import io.swagger.annotations.ApiParam;
import io.swagger.jaxrs.*;

import java.util.Map;
import java.util.List;
import java.io.InputStream;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import eu.decideh2020.acsmi.monitoring.server.api.ApiApiService;
import eu.decideh2020.acsmi.monitoring.server.api.NotFoundException;
import eu.decideh2020.acsmi.monitoring.server.api.factories.ApiApiServiceFactory;
import eu.decideh2020.acsmi.monitoring.server.model.*;

import javax.servlet.ServletConfig;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.*;
import javax.validation.constraints.*;

@Path("/api")


@io.swagger.annotations.Api(description = "the api API")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2018-11-06T10:38:30.646Z")
public class ApiApi  {
   private final ApiApiService delegate;

   public ApiApi(@Context ServletConfig servletContext) {
      ApiApiService delegate = null;

      if (servletContext != null) {
         String implClass = servletContext.getInitParameter("ApiApi.implementation");
         if (implClass != null && !"".equals(implClass.trim())) {
            try {
               delegate = (ApiApiService) Class.forName(implClass).newInstance();
            } catch (Exception e) {
               throw new RuntimeException(e);
            }
         } 
      }

      if (delegate == null) {
         delegate = ApiApiServiceFactory.getApiApi();
      }

      this.delegate = delegate;
   }

    @POST
    @Path("/resourcemonitoring")
    @Consumes({ "resourcemonitoring/json" })
    @Produces({ "*/*" })
    @io.swagger.annotations.ApiOperation(value = "createResourcemonitoring", notes = "Creates a resourcemonitoring to be included in ACSmI monitoring", response = Resourcemonitoring.class, tags={ "resourcemonitoring", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Resource monitoring Created", response = Resourcemonitoring.class),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 404, message = "Not Found", response = Void.class) })
    public Response createResourcemonitoringUsingPOST(@ApiParam(value = "" ,required=true) Resourcemonitoring resourcemonitoring
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.createResourcemonitoringUsingPOST(resourcemonitoring,securityContext);
    }
    @DELETE
    @Path("/resourcemonitoring/{resourceid}")
    @Consumes({ "application/json" })
    @Produces({ "*/*" })
    @io.swagger.annotations.ApiOperation(value = "deleteResourcemonitoring", notes = "", response = Void.class, tags={ "resourcemonitoring", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Resorcemonitoring deleted form the monitoring list", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 204, message = "No Content", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class) })
    public Response deleteResourcemonitoringUsingDELETE(@ApiParam(value = "id",required=true) @PathParam("resourceid") String resourceid
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.deleteResourcemonitoringUsingDELETE(resourceid,securityContext);
    }
    @GET
    @Path("/resourcemonitoring/{resourceid}")
    @Consumes({ "resourcemonitoring/json" })
    @Produces({ "*/*" })
    @io.swagger.annotations.ApiOperation(value = "getResourcemonitoringstatus", notes = "Gets the status wrt monitoring of a given resource", response = Resourcemonitoring.class, tags={ "resourcemonitoring", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Specific resource monitoring is returned", response = Resourcemonitoring.class),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 404, message = "Not Found", response = Void.class) })
    public Response getResourcemonitoringUsingGET(@ApiParam(value = "id",required=true) @PathParam("resourceid") Integer resourceid
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.getResourcemonitoringUsingGET(resourceid,securityContext);
    }
    @PUT
    @Path("/resourcemonitoring/{resourceid}")
    @Consumes({ "resourcemonitoring/json" })
    @Produces({ "*/*" })
    @io.swagger.annotations.ApiOperation(value = "updateResource", notes = "Updates the monitoring status of a given resource", response = Resourcemonitoring.class, tags={ "resourcemonitoring", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Resource Status updated", response = Resourcemonitoring.class),
        
        @io.swagger.annotations.ApiResponse(code = 401, message = "Unauthorized", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 403, message = "Forbidden", response = Void.class),
        
        @io.swagger.annotations.ApiResponse(code = 404, message = "Not Found", response = Void.class) })
    public Response updateResourceUsingPUT(@ApiParam(value = "id",required=true) @PathParam("resourceid") String resourceid
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.updateResourceUsingPUT(resourceid,securityContext);
    }
}
