class AllowMulticontracting < ActiveRecord::Migration
  def change
    drop_table :instance_attributes

    create_table :contracting_resources do |t|
      t.string :session_id, null: false
      t.integer :contract_id
      t.string :input_resource_id
      t.string :service_id
      t.string :service_name
      t.string :resource_id
      t.string :resource_name
      t.integer :index
      t.string :status
    end

    add_column :users, :key_pair_id, :string
    create_table :virtual_machines do |t|
      t.integer :contracting_resource_id
      t.string :csp_id
      t.string :csp_name
      t.string :image
      t.string :software_id
      t.string :region_id
      t.string :instance_type_id
    end

    %i[service_id service_name resource_id resource_name instance_type_id region_id aasm_state].each do |col|
      remove_column :sessions, col
    end

    remove_column :credential_fields, :session_id, :string
    add_column :credential_fields, :contracting_resource_id, :integer
  end
end
