/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A Definition.
 */
@Entity
@Table(name = "definition")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class Definition extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Size(max = 4)
    @Column(name = "code", length = 4, nullable = false)
    private String code;
    
    @NotNull
    @Size(max = 60)
    @Column(name = "value", length = 60, nullable = false)
    private String value;
    
    @NotNull
    @Column(name = "ismainattribute", nullable = false)
    private Boolean ismainattribute;
    
    @NotNull
    @Column(name = "ischeckoption", nullable = false)
    private Boolean ischeckoption;
    
    @Column(name = "typeid", nullable = true)
    private Long typeid;

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public Definition code(String code) {
        this.code = code;
        return this;
    }

    public void setCode(String code) {
        this.code = code;
    }
    
    public String getValue() {
        return value;
    }

    public Definition value(String value) {
        this.value = value;
        return this;
    }

    public void setValue(String value) {
        this.value = value;
    }
    
    public boolean isIsmainattribute() {
        return ismainattribute;
    }

    public Definition ismainattribute(boolean ismainattribute) {
        this.ismainattribute = ismainattribute;
        return this;
    }

    public void setIsmainattribute(boolean ismainattribute) {
        this.ismainattribute = ismainattribute;
    }
    
    public boolean isIscheckoption() {
        return ischeckoption;
    }

    public Definition ischeckoption(boolean ischeckoption) {
        this.ischeckoption = ischeckoption;
        return this;
    }

    public void setIscheckoption(boolean ischeckoption) {
        this.ischeckoption = ischeckoption;
    }
    
    public Long getTypeid() {
        return typeid;
    }

    public Definition typeid(Long typeid) {
        this.typeid = typeid;
        return this;
    }

    public void setTypeid(Long typeid) {
        this.typeid = typeid;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public Definition deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }
    

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Definition definition = (Definition) o;
        if (definition.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), definition.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "Definition{" +
            "id=" + getId() +
            ", code='" + getCode() + "'" +
            ", value='" + getValue() + "'" +
            ", ismainattribute='" + isIsmainattribute() + "'" +
            ", ischeckoption='" + isIscheckoption() + "'" +
            ", typeid='" + getTypeid() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            "}";
    }
}
