/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.Objects;

/**
 * A ServiceClassFullInfoVO.
 */
public class ServiceClassFullInfoVO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;
    private String name;
    private Long attributetypeid;
    private String attributename;
    private String attributenfrname;
    private Boolean isenumeration;
    private Boolean ischecklist;
    private Boolean iscommon;
    private Boolean isfunctionalrequirement;
    private Long parentid;
    private Long childid;
    private String units;
    private String unitfactor;
    private String unitrule;
    private String checklistevalrule;
    private String unitvalue;
    private String checklistvalue;
    private Long classattributeid;
    private Integer weight;
    private Boolean ismandatory;
    
    
    public ServiceClassFullInfoVO() {}
    
    public ServiceClassFullInfoVO(final Long id, final String name, final Long attributetypeid,
    		final String attributename, final String attributenfrname, final Boolean isenumeration,
    		final Boolean ischecklist, final Boolean iscommon, final Boolean isfunctionalrequirement,
    		final Long parentid, final Long childid, final String units, final String unitfactor,
    		final String unitrule, final String checklistevalrule, final Long classattributeid,
    		final Integer weight, final Boolean ismandatory) {
    	this.id = id;
    	this.name = name;
    	this.attributetypeid = attributetypeid;
    	this.attributename = attributename;
    	this.attributenfrname = attributenfrname;
    	this.isenumeration = isenumeration;
    	this.ischecklist = ischecklist;
    	this.iscommon = iscommon;
    	this.isfunctionalrequirement = isfunctionalrequirement;
    	this.parentid = parentid;
    	this.childid = childid;
    	this.units = units;
    	this.unitfactor = unitfactor;
    	this.unitrule = unitrule;
    	this.checklistevalrule = checklistevalrule;
    	this.unitvalue = null;
    	this.checklistvalue = null;
    	this.classattributeid = classattributeid;
    	this.weight = weight;
    	this.ismandatory = ismandatory;
    }

    

    public Long getId() {
        return id;
    }

    public void setId(final Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }
    
    public Long getAttributetypeid() {
        return attributetypeid;
    }

    public void setAttributetypeid(final Long attributetypeid) {
        this.attributetypeid = attributetypeid;
    }
    
    public String getAttributename() {
        return attributename;
    }

    public void setAttributename(final String attributename) {
        this.attributename = attributename;
    }
    
    public String getAttributenfrname() {
        return attributenfrname;
    }

    public void setAttributenfrname(final String attributenfrname) {
        this.attributenfrname = attributenfrname;
    }
    
    public Boolean isIsenumeration() {
        return isenumeration;
    }

    public void setIsenumeration(final Boolean isenumeration) {
        this.isenumeration = isenumeration;
    }
    
    public Boolean isIschecklist() {
        return ischecklist;
    }

    public void setIschecklist(final Boolean ischecklist) {
        this.ischecklist = ischecklist;
    }
    
    public Boolean isIscommon() {
        return iscommon;
    }

    public void setIscommon(final Boolean iscommon) {
        this.iscommon = iscommon;
    }
    
    public Boolean isIsfunctionalrequirement() {
        return isfunctionalrequirement;
    }

    public void setIsfunctionalrequirement(final Boolean isfunctionalrequirement) {
        this.isfunctionalrequirement = isfunctionalrequirement;
    }
    
    public Long getParentid() {
        return parentid;
    }

    public void setParentid(final Long parentid) {
        this.parentid = parentid;
    }
    
    public Long getChildid() {
        return childid;
    }

    public void setChildid(final Long childid) {
        this.childid = childid;
    }
    
    public String getUnits() {
        return units;
    }

    public void setUnits(final String units) {
        this.units = units;
    }
    
    public String getUnitfactor() {
        return unitfactor;
    }

    public void setUnitfactor(final String unitfactor) {
        this.unitfactor = unitfactor;
    }
    
    public String getUnitrule() {
        return unitrule;
    }

    public void setUnitrule(final String unitrule) {
        this.unitrule = unitrule;
    }
    
    public String getChecklistevalrule() {
        return checklistevalrule;
    }

    public void setChecklistevalrule(final String checklistevalrule) {
        this.checklistevalrule = checklistevalrule;
    }
    
    public String getUnitvalue() {
        return unitvalue;
    }

    public void setUnitvalue(final String unitvalue) {
        this.unitvalue = unitvalue;
    }
    
    public String getChecklistvalue() {
        return checklistvalue;
    }

    public void setChecklistvalue(final String checklistvalue) {
        this.checklistvalue = checklistvalue;
    }
    
    public Long getClassattributeid() {
        return classattributeid;
    }

    public void setAttributevalueid(final Long classattributeid) {
        this.classattributeid = classattributeid;
    }
    
    public Integer getWeight() {
        return weight;
    }

    public void setWeight(final Integer weight) {
        this.weight = weight;
    }
    
    public Boolean isIsmandatory() {
        return ismandatory;
    }

    public void setIsmandatory(final Boolean ismandatory) {
        this.ismandatory = ismandatory;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceClassFullInfoVO serviceClassFullInfoVO = (ServiceClassFullInfoVO) o;
        if (serviceClassFullInfoVO.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceClassFullInfoVO.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "ServiceClassFullInfoVO{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", attributetypeid='" + getAttributetypeid() + "'" +
            ", attributename='" + getAttributename() + "'" +
            ", attributenfrname='" + getAttributenfrname() + "'" +
            ", isenumeration='" + isIsenumeration() + "'" +
            ", ischecklist='" + isIschecklist() + "'" +
            ", iscommon='" + isIscommon() + "'" +
            ", isfunctionalrequirement='" + isIsfunctionalrequirement() + "'" +
            ", parentid='" + getParentid() + "'" +
            ", childid='" + getChildid() + "'" +
            ", units='" + getUnits() + "'" +
            ", unitfactor='" + getUnitfactor() + "'" +
            ", unitrule='" + getUnitrule() + "'" +
            ", checklistevalrule='" + getChecklistevalrule() + "'" +
            ", unitvalue='" + getUnitvalue() + "'" +
            ", checklistvalue='" + getChecklistvalue() + "'" +
            ", classattributeid='" + getClassattributeid() + "'" +
            ", weight='" + getWeight() + "'" +
            ", ismandatory='" + isIsmandatory() + "'" +
            "}";
    }
}
