/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;

/**
 * A ServiceDevOpsInfoVO.
 */
public class ServiceDevOpsInfoVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    private String serviceclassname;
    private String providername;
    private Integer numservices;
    
    
    public ServiceDevOpsInfoVO() {
    	serviceclassname = null;
    	providername = null;
    	numservices = null;
    }
    
    public ServiceDevOpsInfoVO(final String serviceclassname, final String providername, final Integer numservices) {
    	this.serviceclassname = serviceclassname;
    	this.providername = providername;
    	this.numservices = numservices;
    }


    public String getServiceclassname() {
		return serviceclassname;
	}

	public void setServiceclassname(String serviceclassname) {
		this.serviceclassname = serviceclassname;
	}

	public String getProvidername() {
		return providername;
	}

	public void setProvidername(String providername) {
		this.providername = providername;
	}
	
	public Integer getNumservices() {
		return numservices;
	}

	public void setNumservices(Integer numservices) {
		this.numservices = numservices;
	}
	

	@Override
    public String toString() {
    	return "ServiceDevOpsInfoVO{" +
                "serviceclassname=" + getServiceclassname() +
                ", providername='" + getProvidername() + "'" +
                ", numservices='" + getNumservices() + "'" +
                "}";
    }
}
