/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.Objects;

/**
 * A ServiceDevOpsInfoVO.
 */
public class ServiceDevOpsQueryInfoVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    private String querykey;
    private String servicename;
    
    
    public ServiceDevOpsQueryInfoVO() {
    	querykey = null;
    	servicename = null;
    }
    
    public ServiceDevOpsQueryInfoVO(final String querykey, final String servicename) {
    	this.querykey = querykey;
    	this.servicename = servicename;
    }


    public String getQuerykey() {
		return querykey;
	}

	public void setQuerykey(String querykey) {
		this.querykey = querykey;
	}

	public String getServicename() {
		return servicename;
	}

	public void setServicename(String servicename) {
		this.servicename = servicename;
	}
	

	@Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceDevOpsQueryInfoVO serviceDevOpsQueryInfoVO = (ServiceDevOpsQueryInfoVO) o;
        if (serviceDevOpsQueryInfoVO.getQuerykey() == null || getQuerykey() == null) {
            return false;
        }
        return Objects.equals(getQuerykey(), serviceDevOpsQueryInfoVO.getQuerykey());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getQuerykey());
    }

    @Override
    public String toString() {
    	return "ServiceDevOpsQueryInfoVO{" +
                "querykey=" + getQuerykey() +
                ", servicename='" + getServicename() + "'" +
                "}";
    }
}
