/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose Lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * Alberto Molinuevo					Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('RegisterController', RegisterController);


    RegisterController.$inject = ['$translate', '$timeout', 'Auth', 'LoginService', 'Definition'];

    function RegisterController ($translate, $timeout, Auth, LoginService, Definition) {
        var vm = this;

        vm.doNotMatch = null;
        vm.error = null;
        vm.errorUserExists = null;
        vm.login = LoginService.open;
        vm.register = register;
        vm.registerAccount = {};
        vm.definitions = null;
        vm.success = null;
        
        loadCSPs();
        
        // Load CSPs
        function loadCSPs() {
	        Definition.query({},
	        		function success(result) {
	        			if (result != null && result.length > 0) {
	        				vm.definitions = new Array();
	        				for (var i = 0;i < result.length;i++) {
	        					if (result[i].typeid == 3) {
	        						vm.definitions.push(result[i]);
	        					}
	        				}
	        			}
					},
					function error(error) {}
	        );
        }

        $timeout(function (){angular.element('#firstName').focus();});

        function register () {
            if (vm.registerAccount.password !== vm.confirmPassword) {
                vm.doNotMatch = 'ERROR';
            } else {
            	vm.selectedusergroup = "admingroup";
            	if (vm.settingsAccount.userType == "csp") {
            		vm.selectedusergroup = "cspgroup";
            	} else if (vm.settingsAccount.userType == "dev") {
            		vm.selectedusergroup = "usergroup";
            	} else if (vm.settingsAccount.userType == "lgl") {
            		vm.selectedusergroup = "legalgroup";
            	}
            	
            	
            	vm.registerAccount = {
                        firstName: vm.registerAccount.firstName,
                        lastName: vm.registerAccount.lastName,
                        login: vm.registerAccount.login,
                        email: vm.registerAccount.email,
                        password: vm.registerAccount.password,
                        langKey: $translate.use(),
                        company: vm.settingsAccount.company,
                        usersGroup: vm.selectedusergroup,
                        userType: vm.settingsAccount.userType,
                        creditCardType: null,
                        creditCard: null,
                        contractReference: null,
                        cifOrVat: "A12345678"
                    };

            	vm.doNotMatch = null;
                vm.error = null;
                vm.errorUserExists = null;
                vm.errorEmailExists = null;
                vm.errorUsersGroupExists = null;
                Auth.createAccount(vm.registerAccount).then(function () {
                    vm.success = 'OK';
                }).catch(function (response) {
                    vm.success = null;
                    if (response.status === 400 && response.data === 'login already in use') {
                        vm.errorUserExists = 'ERROR';
                    } else if (response.status === 400 && response.data === 'email address already in use') {
                        vm.errorEmailExists = 'ERROR';
                    }
                    //else if (response.status === 400 && response.data === 'user group already exists') {
                    //    vm.errorUsersGroupExists = 'ERROR';
                    //}
                	else {
                        vm.error = 'ERROR';
                    }
                });
            }
        }
    }
})();
