/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose Lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * Alberto Molinuevo					Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('UserManagementDialogController',UserManagementDialogController);

    UserManagementDialogController.$inject = ['$scope', '$stateParams', '$uibModalInstance', 'entity', 'User', 'JhiLanguageService', 'Definition'];

    function UserManagementDialogController ($scope, $stateParams, $uibModalInstance, entity, User, JhiLanguageService, Definition) {
        var vm = this;

        vm.authorities = ['ROLE_ADMIN', 'ROLE_CSP', 'ROLE_USER', 'ROLE_LEGAL_EXPERT'];
        
        vm.clear = clear;
        vm.languages = null;
        vm.save = save;
        vm.user = entity;
        vm.definitions = null;
        vm.confirmPassword = null;
        vm.doNotMatch = null;
        
        loadCSPs();
        
        // Load CSPs
        function loadCSPs() {
	        Definition.query({},
	        		function success(result) {
	        			if (result != null && result.length > 0) {
	        				vm.definitions = new Array();
	        				for (var i = 0;i < result.length;i++) {
	        					if (result[i].typeid == 3) {
	        						vm.definitions.push(result[i]);
	        					}
	        				}
	        			}
					},
					function error(error) {}
	        );
        }


        JhiLanguageService.getAll().then(function (languages) {
            vm.languages = languages;
        });
        
        $scope.changeUserType = function() {
        	vm.user.company = null;
        }

        function clear () {
            $uibModalInstance.dismiss('cancel');
        }

        function onSaveSuccess (result) {
            vm.isSaving = false;
            $uibModalInstance.close(result);
        }

        function onSaveError () {
            vm.isSaving = false;
        }

        function save () {
        	/*
            if(vm.user.userType === "csp") {
                vm.user.contractReference = null;
                vm.user.creditCardType = null;
                vm.user.creditCard = null;
            } else if (vm.user.userType === "dev" && vm.user.creditOrContract === "contractreference") {
                vm.user.creditCardType = null;
                vm.user.creditCard = null;
            } else if (vm.user.userType === "pa" && vm.user.creditOrContract === "creditcard") {
                vm.user.contractReference = null;
            }
            */
        	if (vm.user.id === null && vm.user.password !== vm.confirmPassword) {
        		vm.doNotMatch = 'ERROR';
        	} else {
        		vm.doNotMatch = null;
	            vm.isSaving = true;
	            
	            vm.user.usersGroup = "admingroup";
	        	if (vm.user.userType == "csp") {
	        		vm.user.usersGroup = "cspgroup";
	        	} else if (vm.user.userType == "dev") {
	        		vm.user.usersGroup = "usergroup";
	        	} else if (vm.user.userType == "lgl") {
	        		vm.user.usersGroup = "legalgroup";
	        	}
	            vm.user.cifOrVat = "A12345678";
	            
	            if (vm.user.id !== null) {
	                User.update(vm.user, onSaveSuccess, onSaveError);
	            } else {
	                User.save(vm.user, onSaveSuccess, onSaveError);
	            }
        	}
        }
    }
})();
