/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose Lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * Alberto Molinuevo					Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('ServiceController', ServiceController);

    ServiceController.$inject = ['Service', 'Principal'];

    function ServiceController(Service, Principal) {
    	var vm = this;        
        vm.services = [];
        vm.user = null;
        
        loadServices();
        
        // Función de carga de servicios
        function loadServices() {
        	Principal.identity().then(function(account) {
        		vm.user = account;
        		if (vm.user.authorities.length == 1) {
            		Service.cspservices({cspname: vm.user.company}, function(result) {
                    	vm.services = result;
                    	allowDelete();
                    });
            	} else {
            		Service.query(function(result) {
                    	vm.services = result;
                    	allowDelete();
                    });
            	}
            });
        }
        
        
        // Función que determina si un servicio puede ser borrado
        function allowDelete() {
        	if (vm.services != null && vm.services.length > 0) {
				for (var i = 0;i < vm.services.length;i++) {
					vm.services[i].allowLogicalDelete = true;
					vm.services[i].allowReactivate = true;
					vm.services[i].allowPhysicalDelete = true;
				}
				document.getElementById('notFoundDiv').style.display = 'none';
        	} else {
        		document.getElementById('notFoundDiv').style.display = 'block';
        	}
        	
        }
    }
})();
